<?php
/*
:

 * 1  -   ( ,  )
 * for -   
 * sortby -     (tag,time,    )
 * sortorder - ASC/DESC (DESC  )
 * max -  - 
 * modifier -       
 * collectall - 0/1 (0  ) (    (0)    (1))
 * hidepagenumbers - 0/1 (0  ) (    N ,  )
 * filter -  IsHot1:1::Approved:2
 * usetagfilter -    TagCommon
 * pagenumstyle - "prevnext" | "list" (c   )
 * saverequest -      (: "view:tag")
 * showpager - bottom|top|topbottom

:
{{templatesum name="NewsArticle" for="" sortby="pubdate" sortorder="DESC" max="10" modifier="small" collectall=1}}
*/
$servOnto = $this->srvFactory("AdvOntology");
$servWP = $this->srvFactory("WikiPatterns");

if(!$name) $name = $vars[0];

//   
if(!$sortby || !$this->symSome($sortby,'A-Za-z0-9_')) $sortby='_updateTime';
if($sortorder!='ASC') $sortorder='DESC';
$max = (int)$max;

$root = $for;
if (!isset($root)) $root = "/".$this->page["tag"];
if ($root == "/") $root = "";
if ($root) $root = $this->UnwrapLink($root);
$root = $this->NpjTranslit($root);

$savevars = "";
if($saverequest) {
  $t1 = explode(":", $saverequest);
  foreach($t1 as $curvar) {
    if($this->symAlnum($curvar)) {
      $savevars .= "&";
      $savevars .= $curvar.'='.htmlspecialchars($_REQUEST[$curvar]);
    }
  }
}

// check service is installed
if($this->IsService('WikiPatterns')) {
// check template existence
if($restpl = Wptrn_TplByName($this,$name)) {
  $patternName = $restpl["name"];
  if($sortby != '_updateTime') {


    $res = Wptrn_FieldByName($this,$restpl["id"],$sortby);
    // -   ELSE
    //       $RES!!!
  }
  //    
  //$tagcheck = "supertag like '".quote($root)."/%' and not (supertag like '".quote($root)."/%/%')";
  $addcheck = "";
  if($_REQUEST["comtag"] && $usetagfilter=="1") {
    if($this->srvIsInstalled("TagCommon")) {
       $servOnto = $this->srvFactory("AdvOntology");
       $tagId = $servOnto->getConceptIdByData('Tag',$_REQUEST["comtag"]);
       //    
       $res1 = $servOnto->getLinksByConceptIds("PageTag", array("Tag1" => $tagId));
       $pgtagar = array();
       foreach($res1 as $pageids) {
         $pgtagar[] = $pageids["Page1"];
       }
       //   
       $res1 = $servOnto->getConceptsByIds("Page", $pgtagar);
       $pgtagar = array();
       foreach($res1 as $pageids) {
         $pgtagar[] = quote($pageids["data"]);
       }
       $addcheck = " AND pages.id in ('".implode("', '",$pgtagar)."')";
       //echo $addcheck;
    }
  }

  if($collectall!="1") {
     $tagcheck = "supertag like '".quote($root)."/%' and not (supertag like '".quote($root)."/%/%')";
  } else {
     $tagcheck = "supertag like '".quote($root)."/%'";
  }
  $tagcheck .= $addcheck;

  //   
  $query =  "select id from ".
           $this->config["table_prefix"]."pages pages where ".
           $tagcheck;
  //echo $query."<br />";

  $pages = $this->LoadAll($query);
  //print_r($pages);

  $pagesId = $servOnto->utilDBtoIDS($pages);
  /*
  print_r($pagesId);
  echo "<br />";
  $pages1 = $servOnto->getConceptsByData("Page", $pagesId);
  $pagesId = $servOnto->utilDBtoIDS($pages1);
  print_r($pagesId);
  */
     if($max!=0) {
       $cnt = $servOnto->getConceptCount("wp".$patternName, array("data" => $pagesId));
       //echo $cnt;
       $skip = (int)$_REQUEST["skip"];
       if($skip < 0) $skip = 0;
     }

     $filt1 = $servOnto->simpleQueryParse($filter);

     $query =  "select ontopages.".$sortby." as orderfield, pages.id as id, pages.tag as tag, pages.time as time, pages.supertag as supertag from ".
           $this->config["table_prefix"]."pages pages, ".$servOnto->getTableNameByType("wp".$patternName)." ontopages where ".
           $tagcheck.
           " and ontopages.data=pages.id ".
           " and (".$servOnto->utilConditionsToSQL($filt1,"ontopages.").") ORDER BY orderfield ".$sortorder.($max==0?'':' LIMIT '.$skip.','.$max);
     //echo "<br />".$query."<br />";
     $pages = $this->LoadAll($query);

	 //echo htmlspecialchars($query).'<br />';
     //print_r($pages);

  if($pages) {
     foreach($pages as $key => $page){
         //    ?
         if ($data = $servWP->getPageDataPattern($patternName, $page["id"])) {
         //    - ?
         if ($this->HasAccess("read", $page["supertag"])){
            //  
            $pages[$key]['data'] = $data;
         } else {
            unset($pages[$key]);
         }
         } else {
            unset($pages[$key]);
         }
     }
     //$this->context[++$this->current_context] = "";
      ob_start();
      if($hidepagenumbers != "1") {
     if($max!=0) {
          echo "<div align='center' class='templatesum'>";
          if($pagenumstyle != "list") {
                    if($skip > 0) {
                       echo '<a href="'.$this->href('','','skip='.($skip-$max).$savevars).'"> '.$max.'</a>';
                    }
                    if($cnt > $max) { echo " | "; }
                    if(($skip + $max) < $cnt) {
                       echo '<a href="'.$this->href('','','skip='.($skip+$max).$savevars).'"> '.$max.'</a>';
                    }
          } else {
                     if($cnt > $max) {
                            for($i=0;$i*$max<$cnt;$i++) {
                                 echo(
                                      '<a href="'.$this->Href("","","skip=".($i*$max).$savevars).'">'.
                                      ($i*$max+1)."-".(($i+1)*$max>$cnt?$cnt:($i+1)*$max)."</a>&nbsp;&nbsp;");
                            }
                     }

          }
          echo "</div>";
     }
     }
     $pager = ob_get_clean();

     if($showpager == "top" || $showpager == "topbottom") echo $pager;
     echo $this->Format($this->Format(Wptrn_ProcPages($this,$restpl["tplfile"],'sum'.($modifier==''?'':'.'.$modifier),$pages)),"post_wacko");
     if($showpager != "top") echo $pager;
     //$this->current_context--;

  } else {
     echo $nowarning!=1?" ":"";
  } // pages
} else {
  echo "   .";
} // check template existence
} // IsService


?>