<?php
/*
  templatesum,   

  * notpagecheck=1 -     PAGES
  * filecheck=1 -   files
  * addtablecheck -     (: advontotypes_linkDisDuelInfo:advontotypes_linkDisCommentTree)
  * separateacl -     (: *::Authors:::Admins)
  * fakecache=1 -   
*/
if($this->srvIsInstalled("UtilCache")) {

   if(!$name) $name = $vars[0];

   $root = $for;
   if (!isset($root)) $root = "/".$this->page["tag"];
   if ($root == "/") $root = "";
   if ($root) $root = $this->UnwrapLink($root);
   $root = $this->NpjTranslit($root);

   // caching
   $servCache = $this->srvFactory("UtilCache");
   $tableCheck = array("advontotypes_wp".$name);
   if(!$notpagecheck) {
       $tableCheck[] = "pages";
   }
   if($filecheck) {
       $tableCheck[] = "upload";
   }
   if($addtablecheck!="") {
       $addtables = explode(':', $addtablecheck);
       $tableCheck = array_merge($tableCheck,$addtables);
   }
   $aclcheck = array();
   if($separateacl) {
      $sepacls = explode('::', $separateacl);
      //print_r($sepacls);
      foreach($sepacls as $acl) {
        $aclcheck[] = $this->CheckACL($this->GetUsername(), str_replace(':',"\n", $acl));
      }
      //print_r($aclcheck);
   }

   $cachetime = $servCache->getLastTablesUpdateTime($tableCheck);
   //print_r($tableCheck);
   $cacheid = $servCache->getUniID(array("templatesumcachepublic", $name, $root, (int)$_REQUEST["skip"], $modifier,
                                   $collectall, $filter, $max, $sortby, $sortorder, $tableCheck, $aclcheck, $separateacl));

if((($result = $servCache->validCached($cacheid, $cachetime)) === null) || ($fakecache == "1")) {
   ob_start();
   include('extensions/WikiPatterns/actions/templatesum.php');
   $result = ob_get_contents();
   ob_end_clean();
   $servCache->saveCached($cacheid, $result);
}

echo $result;
} else {
  echo "<i>    -  TEMPLATESUM</i>";
}
?>