<?php
/*
   Showing uploaded by {{upload}} files

   {{Files
     [param0="PageName" or global=1]
     [order="time|FILENAME|size|size_desc|ext"]
     [owner="UserName"]
     [pictures=1]
   }}
*/
  //$orderby = "filename ASC";
  $orderby = "uploaded_dt ASC";
  if ($order == "time") $orderby = "uploaded_dt DESC";
  if ($order == "size") $orderby = "filesize ASC";
  if ($order == "size_desc") $orderby = "filesize DESC";
  if ($order == "ext") $orderby = "file_ext ASC";

//  $vars[0] = "!";

  $user_add = "";

  // do we allowed to see?
    $can_view   = $this->HasAccess("read",$vars[0]) || $this->IsAdmin() || $this->UserIsOwner($vars[0]);
    $can_delete = $this->IsAdmin() || $this->UserIsOwner($vars[0]);

    $filepage = $this->page;

    // load files list
    $files = $this->LoadAll( "select id, page_id, filesize, picture_w, picture_h, filename, description, uploaded_dt, user from ".
                              $this->config["table_prefix"]."upload where ".
                             " page_id = '". ($global?0:$filepage["id"])."' ".$user_add.
                             " order by ".$orderby );
    if (!is_array($files)) $files = array();

    if(!isset($header)) {
      $header = "  ";
    }

    if (!$nomark){
      print("<fieldset><legend>".htmlspecialchars($header)."</legend>\n");
    }
    // display
    $kb  = $this->GetResourceValue("UploadKB");
    $del = $this->GetResourceValue("UploadRemove");
    $path = "@".str_replace("/", "@", $this->NpjTranslit($filepage["tag"]))."@";


    $path2 = "file:/".$filepage["tag"]."/";

    // !!!!! patch link not to show pictures when not needed
    if (!$pictures) $path2 = str_replace("file:", "_file:", $path2);

    if (count($files))
    {
    ?>
 <table class="upload" cellspacing="0" cellpadding="0" border="0" width="100%">
  <?php
    }

    foreach( $files as $file )
    {

      $this->filesCache[$file["page_id"]][$file["filename"]] = &$file;

      $dt = $file["uploaded_dt"];
      /*
      $desc = $this->Format( $file["description"], "typografica" );
      if ($desc == "") $desc = "&nbsp;";
      $desc = str_replace('&nbsp;',' ',$desc);
      */
      $desc = htmlspecialchars($file["description"]);
      $filename = $file["filename"];
      // show only not beginnig with _
      if(strchr($filename,'_')!=$filename) {;

      $filesize = ceil($file["filesize"]/1024);
      $link = $this->Link($path2.$filename, "", $desc );

      $remove_href = $this->Href("upload", $vars[0], "remove=".($global?"global":"local")."&file=".$filename);
      ?>
        <tr>
         <td class="file-" nowrap="nowrap"><?php echo $link; ?></td>
         <td class="size-"><span class="size2-">(<?php echo $filesize; ?>&nbsp;<?php
                                                       echo $kb; ?>)</span>&nbsp;</td>
        </tr>
      <?php
      }
    }
    if (count($files))
    {
    ?>
 </table>
  <?php
    }
    if (!$nomark) echo "</fieldset>\n";
    if($this->IsAdmin()) {
      echo '<br /><div align="center"><a href="'.$this->href('upload').'" target="_blank">   </a></div>';
    }

?>